package awais.instagrabber.models;

import android.os.Parcel;
import android.os.Parcelable;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

public final class FollowModel implements Parcelable {
    public static final Creator<FollowModel> CREATOR = new Creator<FollowModel>() {
        @NonNull
        @Override
        public FollowModel createFromParcel(Parcel in) {
            return new FollowModel(in);
        }

        @NonNull
        @Override
        public FollowModel[] newArray(int size) {
            return new FollowModel[size];
        }
    };
    private final String id, username, fullName, profilePicUrl;
    private String endCursor;
    private boolean hasNextPage;

    public FollowModel(final String id, final String username, final String fullName, final String profilePicUrl) {
        this.id = id;
        this.username = username;
        this.fullName = fullName;
        this.profilePicUrl = profilePicUrl;
    }

    protected FollowModel(@NonNull final Parcel in) {
        id = in.readString();
        username = in.readString();
        fullName = in.readString();
        profilePicUrl = in.readString();
        endCursor = in.readString();
        hasNextPage = in.readByte() != 0;
    }

    public String getId() {
        return id;
    }

    public String getUsername() {
        return username;
    }

    public String getFullName() {
        return fullName;
    }

    public String getProfilePicUrl() {
        return profilePicUrl;
    }

    public void setPageCursor(final boolean hasNextPage, final String endCursor) {
        this.endCursor = endCursor;
        this.hasNextPage = hasNextPage;
    }

    public boolean hasNextPage() {
        return endCursor != null && hasNextPage;
    }

    public String getEndCursor() {
        return endCursor;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(@NonNull final Parcel dest, final int flags) {
        dest.writeString(id);
        dest.writeString(username);
        dest.writeString(fullName);
        dest.writeString(profilePicUrl);
        dest.writeString(endCursor);
        dest.writeByte((byte) (hasNextPage ? 1 : 0));
    }

    @Override
    public boolean equals(@Nullable final Object obj) {
        if (obj instanceof FollowModel) {
            final FollowModel model = (FollowModel) obj;
            if (model.getId().equals(id) && model.getUsername().equals(username)) return true;
        }
        return super.equals(obj);
    }
}